/**
 * XmlSerializer Workshop Copyright (c) Simon Steele, 2003
 * see included license.txt for licensing.
 */
using System;
using System.Collections;
using System.Drawing;
using System.IO;
using System.Reflection;
using System.Text.RegularExpressions;
using System.Windows.Forms;
using System.Xml;
using System.Xml.Serialization;

namespace XmlSerializerWorkshop
{
	/// <summary>
	/// Main XmlSerializerWorkshop window.
	/// </summary>
	public class MainForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.MainMenu mainMenu1;
		private System.Windows.Forms.MenuItem menuItem1;
		private System.Windows.Forms.MenuItem menuItem2;
		private System.Windows.Forms.TreeView treTypes;
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.Button button2;
		private System.ComponentModel.IContainer components;
		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.Label lblExDetails;
		private System.Windows.Forms.MenuItem menuItem3;
		private System.Windows.Forms.MenuItem menuItem4;
		private System.Windows.Forms.Button button3;
		private System.Windows.Forms.ToolTip toolTip1;
		private System.Windows.Forms.MenuItem menuItem5;
		private System.Windows.Forms.MenuItem itmPublicOnly;
		private System.Windows.Forms.MenuItem menuItem6;
		private System.Windows.Forms.MenuItem menuItem7;
		private System.Windows.Forms.Label lblInfoTitle;
		private System.Windows.Forms.MenuItem itmDeleteTempFiles;
		private System.Windows.Forms.MenuItem itmRecycle;
		
		System.Collections.Hashtable namespaceNodes = new Hashtable();
		Abuser abuser = new Abuser();

		public Abuser Abuser
		{
			get { return abuser; }
		}

		public MainForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			bool bDoDelete = true;
			bool bNuke = false;

			string sTemp = System.Configuration.ConfigurationSettings.AppSettings["DeleteTempFiles"];
			
			if(sTemp != null && sTemp != "")
				bDoDelete = Boolean.Parse(sTemp);
			itmDeleteTempFiles.Checked = bDoDelete;

			sTemp = System.Configuration.ConfigurationSettings.AppSettings["NukeTempFiles"];

			if(sTemp != null && sTemp != "")
				bNuke = Boolean.Parse(sTemp);
			itmRecycle.Checked = bNuke;

			itmRecycle.Enabled = itmDeleteTempFiles.Checked;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			this.mainMenu1 = new System.Windows.Forms.MainMenu();
			this.menuItem1 = new System.Windows.Forms.MenuItem();
			this.menuItem2 = new System.Windows.Forms.MenuItem();
			this.menuItem3 = new System.Windows.Forms.MenuItem();
			this.menuItem4 = new System.Windows.Forms.MenuItem();
			this.menuItem5 = new System.Windows.Forms.MenuItem();
			this.itmPublicOnly = new System.Windows.Forms.MenuItem();
			this.itmDeleteTempFiles = new System.Windows.Forms.MenuItem();
			this.menuItem6 = new System.Windows.Forms.MenuItem();
			this.menuItem7 = new System.Windows.Forms.MenuItem();
			this.treTypes = new System.Windows.Forms.TreeView();
			this.button1 = new System.Windows.Forms.Button();
			this.button2 = new System.Windows.Forms.Button();
			this.panel1 = new System.Windows.Forms.Panel();
			this.button3 = new System.Windows.Forms.Button();
			this.lblExDetails = new System.Windows.Forms.Label();
			this.lblInfoTitle = new System.Windows.Forms.Label();
			this.toolTip1 = new System.Windows.Forms.ToolTip(this.components);
			this.itmRecycle = new System.Windows.Forms.MenuItem();
			this.panel1.SuspendLayout();
			this.SuspendLayout();
			// 
			// mainMenu1
			// 
			this.mainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItem1,
																					  this.menuItem5,
																					  this.menuItem6});
			// 
			// menuItem1
			// 
			this.menuItem1.Index = 0;
			this.menuItem1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItem2,
																					  this.menuItem3,
																					  this.menuItem4});
			this.menuItem1.Text = "&File";
			// 
			// menuItem2
			// 
			this.menuItem2.Index = 0;
			this.menuItem2.Shortcut = System.Windows.Forms.Shortcut.CtrlO;
			this.menuItem2.Text = "&Open Assembly...";
			this.menuItem2.Click += new System.EventHandler(this.menuItem2_Click);
			// 
			// menuItem3
			// 
			this.menuItem3.Index = 1;
			this.menuItem3.Text = "-";
			// 
			// menuItem4
			// 
			this.menuItem4.Index = 2;
			this.menuItem4.Text = "E&xit";
			this.menuItem4.Click += new System.EventHandler(this.menuItem4_Click);
			// 
			// menuItem5
			// 
			this.menuItem5.Index = 1;
			this.menuItem5.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.itmPublicOnly,
																					  this.itmDeleteTempFiles,
																					  this.itmRecycle});
			this.menuItem5.Text = "&Options";
			// 
			// itmPublicOnly
			// 
			this.itmPublicOnly.Checked = true;
			this.itmPublicOnly.Index = 0;
			this.itmPublicOnly.Text = "&Public Types Only";
			this.itmPublicOnly.Click += new System.EventHandler(this.itmPublicOnly_Click);
			// 
			// itmDeleteTempFiles
			// 
			this.itmDeleteTempFiles.Index = 1;
			this.itmDeleteTempFiles.Text = "&Delete Temporary Files";
			this.itmDeleteTempFiles.Click += new System.EventHandler(this.itmDeleteTempFiles_Click);
			// 
			// menuItem6
			// 
			this.menuItem6.Index = 2;
			this.menuItem6.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItem7});
			this.menuItem6.Text = "&Help";
			// 
			// menuItem7
			// 
			this.menuItem7.Index = 0;
			this.menuItem7.Text = "&About";
			this.menuItem7.Click += new System.EventHandler(this.menuItem7_Click);
			// 
			// treTypes
			// 
			this.treTypes.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.treTypes.ImageIndex = -1;
			this.treTypes.Location = new System.Drawing.Point(8, 8);
			this.treTypes.Name = "treTypes";
			this.treTypes.SelectedImageIndex = -1;
			this.treTypes.Size = new System.Drawing.Size(392, 168);
			this.treTypes.TabIndex = 0;
			this.treTypes.AfterSelect += new System.Windows.Forms.TreeViewEventHandler(this.treTypes_AfterSelect);
			// 
			// button1
			// 
			this.button1.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.button1.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.button1.Location = new System.Drawing.Point(408, 8);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(88, 24);
			this.button1.TabIndex = 1;
			this.button1.Text = "Test &One";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// button2
			// 
			this.button2.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.button2.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.button2.Location = new System.Drawing.Point(408, 40);
			this.button2.Name = "button2";
			this.button2.Size = new System.Drawing.Size(88, 24);
			this.button2.TabIndex = 2;
			this.button2.Text = "Test &All";
			this.button2.Click += new System.EventHandler(this.button2_Click);
			// 
			// panel1
			// 
			this.panel1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.panel1.BackColor = System.Drawing.SystemColors.Info;
			this.panel1.Controls.Add(this.button3);
			this.panel1.Controls.Add(this.lblExDetails);
			this.panel1.Controls.Add(this.lblInfoTitle);
			this.panel1.Location = new System.Drawing.Point(8, 184);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(488, 176);
			this.panel1.TabIndex = 3;
			// 
			// button3
			// 
			this.button3.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.button3.Location = new System.Drawing.Point(456, 144);
			this.button3.Name = "button3";
			this.button3.Size = new System.Drawing.Size(24, 24);
			this.button3.TabIndex = 2;
			this.button3.TabStop = false;
			this.button3.Text = "...";
			this.toolTip1.SetToolTip(this.button3, "Show full exception details...");
			this.button3.Click += new System.EventHandler(this.button3_Click);
			// 
			// lblExDetails
			// 
			this.lblExDetails.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.lblExDetails.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.lblExDetails.ForeColor = System.Drawing.SystemColors.InfoText;
			this.lblExDetails.Location = new System.Drawing.Point(8, 24);
			this.lblExDetails.Name = "lblExDetails";
			this.lblExDetails.Size = new System.Drawing.Size(472, 144);
			this.lblExDetails.TabIndex = 1;
			// 
			// lblInfoTitle
			// 
			this.lblInfoTitle.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.lblInfoTitle.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblInfoTitle.ForeColor = System.Drawing.SystemColors.InfoText;
			this.lblInfoTitle.Location = new System.Drawing.Point(8, 8);
			this.lblInfoTitle.Name = "lblInfoTitle";
			this.lblInfoTitle.Size = new System.Drawing.Size(128, 16);
			this.lblInfoTitle.TabIndex = 0;
			this.lblInfoTitle.Text = "Details:";
			// 
			// itmRecycle
			// 
			this.itmRecycle.Index = 2;
			this.itmRecycle.Text = "&Send to the Recycle Bin";
			this.itmRecycle.Click += new System.EventHandler(this.itmRecycle_Click);
			// 
			// MainForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(504, 369);
			this.Controls.Add(this.panel1);
			this.Controls.Add(this.button2);
			this.Controls.Add(this.button1);
			this.Controls.Add(this.treTypes);
			this.Menu = this.mainMenu1;
			this.Name = "MainForm";
			this.Text = "XmlSerializer Workshop";
			this.panel1.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		private void menuItem2_Click(object sender, System.EventArgs e)
		{
			OpenFileDialog fd = new OpenFileDialog();
			fd.Title = "Open Assembly";
			fd.Filter = "Assembly Files (*.exe, *.dll)|*.exe;*.dll";

			if( fd.ShowDialog() == DialogResult.OK )
			{
				openAssembly( fd.FileName );
			}
		}

		/// <summary>
		/// This should create an appropriate depth node in the
		/// tree for the namespace.
		/// 
		/// Currently just adds the full namespace as a path.
		/// </summary>
		/// <param name="ns">Namespace name.</param>
		/// <returns>Tree Node added.</returns>
		private TreeNode createNamespaceNode(string ns)
		{
			TreeNode tn = new TreeNode(ns);
			tn.Tag = null;
			treTypes.Nodes.Add(tn);

			namespaceNodes.Add(ns, tn);

			return tn;
		}

		private void clear()
		{
			treTypes.Nodes.Clear();
		}

		private void openAssembly(string filename)
		{
			clear();

			abuser.LoadAssembly( filename );

			foreach(Type type in abuser.Types)
			{
				// Optionally public types only...
				if( itmPublicOnly.Checked && !type.IsPublic )
					continue;

				// No interfaces...
				if( type.IsInterface )
					continue;

				TreeNode tnParent;

				if( namespaceNodes.ContainsKey(type.Namespace) )
				{
					tnParent = (TreeNode)namespaceNodes[type.Namespace];
				}
				else
				{
					tnParent = createNamespaceNode(type.Namespace);
				}

				TreeNode tnItem = new TreeNode( type.Name );
				TestInfo ti = new TestInfo();
				ti.type = type;
				tnItem.Tag = ti;
				tnParent.Nodes.Add(tnItem);
				tnParent.Expand();
			}
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
			if( treTypes.SelectedNode != null )
			{
				testNode(treTypes.SelectedNode);
				selectNode(treTypes.SelectedNode);
			}
		}

		private bool testNode(TreeNode tn)
		{
			if(tn.Tag == null)
				return false;

			try
			{
				TestInfo info = (TestInfo)tn.Tag;
				bool bResult = abuser.AnalyseType(info);

				if(!bResult)
					tn.ForeColor = Color.Red;

				return bResult;
			}
			catch(Exception ex)
			{
				MessageBox.Show("Uncaught Exception!!\n\n" + ex.ToString());
			}

			return false;
		}

		private void treTypes_AfterSelect(object sender, System.Windows.Forms.TreeViewEventArgs e)
		{
			selectNode(e.Node);
		}

		private void selectNode( TreeNode node )
		{
			if(node != null && node.Tag != null)
			{
				TestInfo info = (TestInfo)node.Tag;
				if(info.Tested && !info.CanSerialize)
				{
					// There was some form of error creating the serialization information.

					if(info.HasSourceAndData)
					{
						lblInfoTitle.Text = "Load error details:";
						lblExDetails.Text = "The compiled assembly could not be loaded. Click ... for more information.";
					}
					else
					{
						lblInfoTitle.Text = "Exception details:";

						string msg = "";
						if(info.message != null && info.message.Length > 0)
						{
							msg = info.message;
						}
						lblExDetails.Text = msg + "\n\nClick ... for full exception traces.";
					}
					
					button3.Enabled = true;
					button3.Tag = info;
				}
				else if( info.Tested )
				{
					// We created an XmlSerializer ok, so we display information about it.

					lblInfoTitle.Text = "Details:";
					button3.Enabled = false;
					button3.Tag = null;

					if(info.assembly != null)
					{
						string msg = "Generated Assembly: " + info.assembly.GetName().Name;
						msg += "\nLocation: " + info.assembly.Location;
						msg += "\n\nTypes: ";
						foreach(Type t in info.assembly.GetTypes())
						{
							msg += "\n\t" + t.Name + "  (" + t.Namespace + ")";
						}
						lblExDetails.Text = msg;
					}
				}
				else
				{
					// Erm, dunno.
					lblInfoTitle.Text = "Details:";
					button3.Tag = null;
					button3.Enabled = false;
					lblExDetails.Text = string.Empty;
				}
			}
			else
			{
				// Not a type.
				lblInfoTitle.Text = "Details:";
				button3.Tag = null;
				button3.Enabled = false;
				lblExDetails.Text = string.Empty;
			}
		}

		private void button2_Click(object sender, System.EventArgs e)
		{
			try
			{
				walkTree( treTypes.Nodes );
			}
			catch( NullReferenceException ex)
			{
				MessageBox.Show( ex.ToString() );
			}
		}

		private void walkTree( TreeNodeCollection nodes )
		{
			Cursor oldCursor = this.Cursor;
			this.Cursor = System.Windows.Forms.Cursors.WaitCursor;
			try
			{
				foreach(TreeNode node in nodes)
				{
					walkTree(node.Nodes);
					testNode(node);
				}
			}
			finally
			{
				this.Cursor = oldCursor;
			}
		}

		private void menuItem4_Click(object sender, System.EventArgs e)
		{
			Close();
		}

		private void button3_Click(object sender, System.EventArgs e)
		{
			TestInfo ti = (TestInfo) ((Button)sender).Tag;
			if(ti != null)
			{
				if(ti.HasSourceAndData)
				{
					SourceViewer sv = new SourceViewer();
					sv.Info = ti;
					sv.ShowDialog();
				}
				else
				{
					ExceptionViewer ev = new ExceptionViewer();
					ev.Info = ti;
					ev.ShowDialog();
				}
			}
		}

		private void itmPublicOnly_Click(object sender, System.EventArgs e)
		{
			itmPublicOnly.Checked = !itmPublicOnly.Checked;
		}

		private void menuItem7_Click(object sender, System.EventArgs e)
		{
			About a = new About();
			a.ShowDialog(this);
		}

		private void itmDeleteTempFiles_Click(object sender, System.EventArgs e)
		{
			itmDeleteTempFiles.Checked = !itmDeleteTempFiles.Checked;
			System.Configuration.ConfigurationSettings.AppSettings.Set("DeleteTempFiles", itmDeleteTempFiles.Checked.ToString());
			itmRecycle.Enabled = itmDeleteTempFiles.Checked;
		}

		private void itmRecycle_Click(object sender, System.EventArgs e)
		{
			itmRecycle.Checked = !itmRecycle.Checked;
			System.Configuration.ConfigurationSettings.AppSettings.Set("NukeTempFiles", (!itmRecycle.Checked).ToString());
		}
	}
}
